#include <stdio.h>
#include <stdlib.h>

typedef struct
{
    int ora;
    int perc;
    int azon;
    char irany[3];
} athaladas;

typedef athaladas athaladas_tomb[1000];

int feladat1(athaladas *athaladasok, int *athaladasok_szama, int *szemelyek, int *amikor_a_legtobben_voltak_bent_sorszam)
{
    FILE *ajto_txt = fopen("ajto.txt", "r");
    if (ajto_txt == NULL)
    {
        printf("Nem sikerult megnyitni az ajto.txt allomanyt!");
        return 0;
    }
    int i = 0, egyszerre_bentlevok_szama = 0, egyszerre_bentlevok_legnagyobb_szama = 0;
    while (fscanf(ajto_txt, "%d %d %d %s", &athaladasok[i].ora, &athaladasok[i].perc, &athaladasok[i].azon, athaladasok[i].irany) == 4)
    {
        //printf("%d %d %d %s\n", athaladasok[i].ora, athaladasok[i].perc, athaladasok[i].azon, athaladasok[i].irany);
        szemelyek[athaladasok[i].azon - 1]++;
        if (athaladasok[i].irany[0] == 'b')
        {
            egyszerre_bentlevok_szama++;
        }
        else
        {
            egyszerre_bentlevok_szama--;
        }
        if (egyszerre_bentlevok_szama > egyszerre_bentlevok_legnagyobb_szama)
        {
            egyszerre_bentlevok_legnagyobb_szama = egyszerre_bentlevok_szama;
            *amikor_a_legtobben_voltak_bent_sorszam = i;
        }
        i++;
    }
    *athaladasok_szama = i;
    fclose(ajto_txt);
    return 1;
}

void feladat2(athaladas *athaladasok, int athaladasok_szama)
{
    printf("2. feladat\n");
    if (athaladasok_szama == 0)
    {
        printf("A vizsgalt idoszakon belul nem volt athaladas a tarsalgo ajtajan!");
    }
    else
    {
        printf("Az elso belepo: %d\n", athaladasok[0].azon);
        int i;
        for (i = athaladasok_szama - 1; i > 0 && athaladasok[i].irany[0] != 'k'; i--);
        if (i == 0)
        {
            printf("A vizsgalt idoszakon belul nem volt kilepo!");
        }
        else
        {
            printf("Az utolso kilepo: %d", athaladasok[i].azon);
        }
    }
}

void feladat34(int *szemelyek)
{
    FILE *athaladas_txt = fopen("athaladas.txt", "w");
    if (athaladas_txt == NULL)
    {
        printf("\n\n3. feladat\nNem sikerult irasra megnyitni az athaladas.txt allomanyt!");
        printf("\n\n4. feladat\nA vegen a tarsalgoban voltak:");
        for (int i = 0; i < 100; i++)
        {
            if (szemelyek[i] % 2 == 1)
            {
                printf(" %d", i + 1);
            }
        }
    }
    else
    {
        printf("\n\n4. feladat\nA vegen a tarsalgoban voltak:");
        for (int i = 0; i < 100; i++)
        {
            if (szemelyek[i] > 0)
            {
                fprintf(athaladas_txt, "%d %d\n", i + 1, szemelyek[i]);
                if (szemelyek[i] % 2 == 1)
                {
                    printf(" %d", i + 1);
                }
            }
        }
        fclose(athaladas_txt);
    }
}

void feladat5(athaladas *athaladasok, int sorszam)
{
    printf("\n\n5. feladat\nPeldaul %02d:%02d-kor voltak a legtobben a tarsalgoban.", athaladasok[sorszam].ora, athaladasok[sorszam].perc);
}

void feladat678(athaladas *athaladasok, int athaladasok_szama, int *szemelyek)
{
    int azon, osszesen_bent_toltott_ido = 0, belepes_sorszama = 0;
    printf("\n\n6. feladat\nAdja meg a szemely azonositojat! ");
    scanf("%d", &azon);
    printf("\n7. feladat");
    for (int i = 0; i < athaladasok_szama; i++)
    {
        if (athaladasok[i].azon == azon)
        {
            if (athaladasok[i].irany[0] == 'b')
            {
                printf("\n%02d:%02d-", athaladasok[i].ora, athaladasok[i].perc);
                belepes_sorszama = i;
            }
            else
            {
                printf("%02d:%02d", athaladasok[i].ora, athaladasok[i].perc);
                osszesen_bent_toltott_ido += athaladasok[i].ora * 60 + athaladasok[i].perc - (athaladasok[belepes_sorszama].ora * 60 + athaladasok[belepes_sorszama].perc);
            }
        }
    }
    printf("\n\n8. feladat");
    if (szemelyek[azon - 1] % 2 == 0)
    {
        printf("A(z) %d. szemely osszesen %d percet volt bent, a megfigyeles vegen nem volt a tarsalgoban.", azon, osszesen_bent_toltott_ido);
    }
    else
    {
        osszesen_bent_toltott_ido += 900 - (athaladasok[belepes_sorszama].ora * 60 + athaladasok[belepes_sorszama].perc);
        printf("A(z) %d. szemely osszesen %d percet volt bent, a megfigyeles vegen a tarsalgoban volt.", azon, osszesen_bent_toltott_ido);
    }
}

int main()
{
    athaladas_tomb athaladasok;
    int athaladasok_szama, szemelyek[100] = {0}, amikor_a_legtobben_voltak_bent_sorszam;
    if (feladat1(athaladasok, &athaladasok_szama, szemelyek, &amikor_a_legtobben_voltak_bent_sorszam))
    {
        feladat2(athaladasok, athaladasok_szama);
        feladat34(szemelyek);
        feladat5(athaladasok, amikor_a_legtobben_voltak_bent_sorszam);
        feladat678(athaladasok, athaladasok_szama, szemelyek);
    }
    return 0;
}
